<!--
The first three sections: "Problem to solve", "Intended users" and "Proposal",
are strongly recommended, while the rest of the sections can be filled out during
the problem validation or breakdown phase. However, keep in mind that providing
complete and relevant information early helps our product team validate the
problem and start working on a solution.
-->

### Problem to solve

<!--
What problem do we solve? Try to define the who/what/why of the opportunity as a user story.
For example, "As a (who), I want (what), so I can (why/value)."
-->

### Intended users

<!--
Who will use this feature? If known, include any of the following: types of users
(e.g. Developer), or specific company roles (e.g. Release Manager). It's okay to write "Unknown".
-->

### Further details

<!--
Include use cases, benefits, goals, or any other details that will help us understand
the problem better.
-->

### Proposal

<!--
How are we going to solve the problem? Try to include the user journey!
-->

### Documentation

<!--
Add all known documentation requirements in this section.
-->

### Availability and Testing

<!--
This section needs to be retained and filled in during the workflow planning
breakdown phase of this feature proposal, if not earlier.

What risks does this change pose? How might it affect the quality of the product?
What additional test coverage or changes to tests will be needed?
-->

### What does success look like, and how can we measure that?

<!--
Define both the success metrics and acceptance criteria. Note that success metrics
indicate the desired business outcomes, while acceptance criteria indicate when
the solution is working correctly.
-->

### Links / references

<!--
E.g. related issues and merge requests, external resources.
For relations to other issues in Gitlab, please use the standard Gitlab format
'group/project#issue_number' to allow easy automatic linking.
-->

### Issue Planning (for developers only)

<!-- Projected start date for handling this issue. -->

StartDate: 2020-04-01

<!-- Expected completion date for this issue. -->

DueDate: 2020-04-01

<!-- Issue impact, 1 (lowest) to 10 (highest). -->

/weight 1

<!-- Estimate of total time needed to solve this issue. -->

/estimate 2d 5m

<!-- Time already spent on this issue. -->

/spend 5m

<!-- Labels to add to this issue. Use ~"Short Term" for planning. -->

/label ~enhancement, ~"Long Term"
